# -*- coding: utf-8 -*-
"""
Created on Fri Aug  5 11:38:03 2016

@author: akibdpt
"""
"""
 * An Element specifies an abstract data element to a {Sort}. An
 * element may specify either a component element or a container element,
 * having either a single value or multiple, alternative, values, respectively.
 * An {Individual} defines a component element with a single value.
 * A {sortal.form.Form} defines a container element as a collection of
 * individuals, or forms, resulting in an element with multiple values. Every
 * sort defines an algebraic behavior on its forms that is derived from a
 * partial order relationship defined on its individuals and forms.
 *
 * An element may have an associate individual assigned. When a form is
 * assigned as an attribute to an individual, this individual becomes the
 * associate to this form and, at the same time, to any individual within this
 * form. However, some individuals, such as {sortal.ind.Relation}s,
 * may belong to more than one form and, thus, have more than one associate
 * individual. In such cases, the associate individual of the element would be
 * null, in order to avoid any ambiguity.
 * 
 * The Element class is an abstract class that implements the
 * Comparable interface. The Element class specifies the
 * common ground for all elements of a sort. Every element belongs to a
 * {Sort}, and can be converted to belong to a different sort (upon
 * condition that the sorts can be matched). Each element can be bound,
 * indicating that the element belongs to a form, and each bound element may
 * have an associate individual assigned.
 * All sorts share a degenerate element value. The nil value represents
 * an element with no value (either an individual with no value or an empty
 * form).
"""
class element():
    """
    initializing the element
    an element (individual or form) needs to belong to a sort
    an element can also be associated with another element: the element belongs
    to a form or the element is a codescriptor of another element
    """
    def __init__(self, sort):
        self.assoc = None
        self.sort = sort
        self.nil= True
        self.key = ''
    """
    check equality
    """
    def __eq__(self, other):
        if other is None or self.type != other.type:
            return False        
        return self.compareValue(other) == 0
    
    """
    less than
    """
    def __lt__(self, other):
        if self.compareValue(other) == -1:
            return True
        return False
    """
    less than or equals to
    """
    def __le__(self, other):
        if self.compareValue(other) < 1 :
            return True
        return False
    """
    greater than
    """
    def __gt__(self, other):
        if self.compareValue(other) == 1:
            return True
        return False
    """
    greater than or equals to
    """
    def __ge__(self, other):
        if self.compareValue(other) > -1:
            return True
        return False
        
    def accept(self):
        raise NotImplementedError 
        
    def compareValue(self):
        raise NotImplementedError 
                
    def edit(self, editor):
        raise NotImplementedError
    
    """
    transforming the element, essentially editing the element with the transform
    set as editor
    """
    def transform(self, tfSet):
        return self.edit(tfSet)
        
    """
    duplicating the element
    """
    def duplicate(self):
        if 'ind' in self.type:
            return self.duplicateInd()
        else:
            return self.duplicateForm()
                
    #------------------------------------------------------------
"""    
    def hashcode(self):
        return
    def clear(self):
        return 
    def parse(self):
        return 
    def parse(self):
        return 
    def convert(self):
        return 
    def transform(self):
        return   
""" 