# -*- coding: utf-8 -*-
"""
Created on Tue Sep  6 12:36:49 2016

@author: akibdpt
"""
from .detection import detection
from .ruleApplication import ruleApplication
from ..transform.transformSet import transformSet as tfSet

class rule():
    
    def __init__(self, name, description, lhs, rhs):
        self.name = name
        self.description = description
        lhs.maximalize()
        rhs.maximalize()
        self.lhs = lhs 
        self.rhs = rhs 
        self.lhsf = lhs.convertFloat()
        self.rhsf = rhs.convertFloat()
        
        self.type = 'MIXED'
        if (rhs.partOf(lhs)):
            self.type = 'SUBTRACTIVE'
        elif (lhs.partOf(rhs)):
            self.type = 'ADDITIVE'
        self.detection = detection(self)
        
    def detect(self, form):
        form.maximalize()
        return self.detection.detect(form)

    def apply(self, form, transformSet = None, setNum = 0):
        form.maximalize()
        if transformSet is None:
            appSet = self.detection.detect(form)
            #print(len(appSet),'matches found')
            if len(appSet) != 0:
                """
                for i in appSet:
                    print('********************************************')
                    i.transformSet[0].printTransf()
                    transfSet = tfSet()
                    transfSet.add(i.transformSet[0])
                    self.lhsf.transform(transfSet).printE()
                """
                appSet[setNum].perform(form)
            return form
        else:
            tlhs = self.lhs.transform(transformSet)
            trhs = self.rhs.transform(transformSet)
            if (tlhs.partOf(form) and (self.type != 'ADDITIVE' or not trhs.partOf(form))):
                application = ruleApplication(self, transformSet, None, tlhs, trhs)
                return application.perform(form)
            return form
            