# -*- coding: utf-8 -*-
"""
Created on Tue Sep  6 12:37:21 2016

@author: akibdpt
"""
from ..visit.elementVisitor import elementVisitor
from ..struct.fragmentTree import treeLink
from .fragment import fragment
from math import pi

class ruleAnalysis(elementVisitor):
    def __init__(self, lhs):
        self.fragments = []
        self.roots = []
        self.maps = {}
        self.current = None
        lhs.accept(self)
        
        
    def setRefl(self, num):
        for i in self.maps.values():
            if i.__class__.type == 'map-distinguishable-similarityMap2D' or i.__class__.type == 'map-distinguishable-similarityMap3D':
                i.reflection = num
        return

    def getMap(self, sort):
        #try:
            return self.maps[sort.baseSort().mapping()]
        #except KeyError:
            #return None
    
    def makeFragments(self, sort, parent):
        frag = treeLink(fragment(sort), parent)
        
        self.fragments.append(frag)
        if parent is None:
            self.roots.append(frag)
        else: parent.children.append(frag)
        mapping = sort.baseSort().mapping()
        if mapping not in self.maps:
            self.maps[mapping] = mapping.getInstance()
        return frag
        
    def visitEnter(self, visit):
        if 'ind' in visit.type:
            if len(self.fragments) == 0:
                self.current = self.makeFragments(visit.sort, None)
            self.current.content.addIndividual(self.getMap(visit.sort), visit) 
            #print('ind', str(self.fragments))
        elif 'form' in visit.type:
            #print('form', str(self.fragments))
            if visit.sort.type == 'sort-disjunctive':
                return True
            if visit.assoc is None or self.current is None:
                self.current = self.makeFragments(visit.sort, None)
            elif self.current.content.sort != visit.sort:
                found = False
                for i in self.current.children:
                    if i.content.sort == visit.sort:
                        self.current = i
                        found = True
                if found == False:
                    self.current = self.makeFragments(visit.sort, self.current)
        return True
        
    def visitLeave(self, visit):
        if 'ind' in visit.type:
            return
        elif 'form' in visit.type:
            if visit.sort.type == 'sort-disjunctive':
                return
            if self.current is not None and self.current.content.sort == visit.sort:
                self.current = self.current.parent
        return 
        
    def visitAssoc(self):
        return 
        
    def unsetVisitedAll(self):
        for i in self.fragments:
            i.content.visited = True
            
        