# -*- coding: utf-8 -*-
"""
Created on Fri Nov  4 11:01:10 2016

@author: akibdpt
"""
from .individual import individual
from enum import Enum

class enumerative(individual):
    
    def __init__(self, sort, value = -1):
        super().__init__(sort)
        self.type = 'ind-enumerative'
        if isinstance(value, int):
            self.value = value
            return
        enums = self.sort.base().arguments
        for i in range(len(enums.values)):
            if enums.values[i] == value:
                self.value = i
                return 
        raise ValueError('Argument is not a valid enumerative value')
    
        
    def strValue(self):
        return self.sort.base().arguments.values[self.value]
        
    def ranking(self, other):
        return self.sort.base().arguments.rankings[self.value][other.value]
    
    def printVal(self):
        return str(self.strValue())
        
    def isNil(self):
        if self.value == -1:
            return True
        return False
        
    def compareValue(self, other):
        d = self.value - other.value
        if d < 0:
            return -1
        elif d > 0:
            return 1
        else:
            return 0
    
    def contains(self, other):
        return not self.isNil() and not other.isNil() and self.compareValue(other) == 0
        
    def combine(self, other):
        if other is None or other.isNil():
            return not self.isNil()
        if self.isNil():
            self.value = other.value
        else:
            self.value = self.ranking(other)
        return True
        
    def common(self, other):
        if self.isNil() or other == None or other.isNil():
            return False
        return self.compareValue(other) == 0
        
    def complement(self, other):
        if self.isNil():
            return False
        if other is None or other.isNil():
            return True
        return self.compareValue(other) != 0
        
    def symcomplement(self, other):
        if self.isNil():
            return False
        if other is None or other.isNil():
            return True
        return self.compareValue(other) != 0
        
    def duplicateInd(self):
        return enumerative(self.sort, self.value)
