# -*- coding: utf-8 -*-
"""
Created on Fri Aug  5 10:41:58 2016

@author: akibdpt
"""
from .individual import individual
from copy import deepcopy
"""
 * A label is an alphanumerical data entity with a discrete behavior,
 * i.e., the value of the sum of two labels is the collection of both labels,
 * unless both labels are identical, in which case is is either label.
 * 
 * The Label class extends on the Individual class.
 * It defines the characteristic individual for labels.
 * A label is represented as a string.
 * This characteristic individual accepts no parameters.
 * It specifies an {sortal.map.ExactMap} as default.
 * Forms of labels adhere to a discrete behavior.
"""
class label(individual):
            
    """
    initialize label
    label contains: type: 'ind-label', value: a string
    """
    def __init__(self, sort = None, s = None):
        super().__init__(sort)
        self.type = 'ind-label'
        if s == None:
            self.value = ''
        else:
            self.value = s
            
    """
    print out a string representing the value of this point,
    used in form.printE()
    """
    def printVal(self):
        return str(self.value)   
         
    """
    return the length of the value string
    """
    def length(self):
        return len(self.value)
        
    """
    check if the label is empty
    """
    def isNil(self):
        return self.value == ''
        
    """
    check equality
    """
    def __eq__(self, other):
        if other is None or other.type != 'ind-label':
            return False
        if self.sort == other.sort:
            return (self.value == other.value)
            
    """
    comparing value of 2 labels
    """
    def compareValue(self, other):
        if self.value > other.value:
            return 1
        elif self.value == other.value:
            return 0
        return -1   
        
    """
    duplicating a label
    """
    def duplicateInd(self):
        duplicate = label(self.sort, self.value)
        if self.attribute is not None:
            duplicate.setAttribute(deepcopy(self.attribute))
        return duplicate

    #-------------------------------------------------------------

"""
    def toStringInd(self):
        return 
    def parse(self):
        return    
""" 