# -*- coding: utf-8 -*-
"""
Created on Thu Jan  5 14:37:30 2017

@author: akibdpt
"""


class parse():
    
    
    
    IDENTIFIER = 'a';
    NUMBER = '0';
    STRING = '"';
    LOGICALAND = 'n';
    LOGICALOR = 'o';
    GREATERQ = 'g';
    LESSQ = 'l';
    NOTEQUAL = 't';
    EQUALS = 's';
    MINUS = '-';
    
    formats = {}
    CURRENT = 0
    PREVIEW = 1
    TRAILER = 2    
    
    
    class parseToken():
        def __init__(self, reader):
            self.reader = reader
            self.value = 0
            self.line = 0
            self.index = 0
            self.endex = 0
            self.text = None
            
        def __str__(self):
            return self.text[self.index - 1: self.endex]
            
        def parse(self):
            self.value = 0
            self.text = None
            self.index = 0
            self.endex = 0
            if self.reader.index == len(self.reader.string) and self.reader.readln() is None:
                return self.reader.index
            if self.advance():
                self.endex = self.span(self.index)
            return self.endex
            
        def advance(self):
            self.text = self.reader.string
            self.index = self.reader.index
            self.line = self.reader.line
            self.index += 1
            self.value = self.text[self.index]
            
            if ((self.value >= 'a' and self.value <= 'z') or
                (self.value >= 'A' and self.value <= 'Z') or
                 self.value == '_'):
                     self.value = parse.IDENTIFIER
            elif self.value >= '0' and self.value <= '9':
                self.value = parse.NUMBER
            elif self.value == '"':
                self.value = parse.STRING
            
            if self.index >= len(self.text):
                return True
                
            nextVal = self.text[self.index]
            if nextVal == self.value:
                if self.value == '/':
                    if self.reader.readln() is None:
                        return False
                    return self.advance()
            
                if self.value == '=':
                    self.value = parse.EQUALS
                elif self.value == '&':
                    self.value = parse.LOGICALAND
                elif self.value == '|':
                    self.value = parse.LOGICALOR
                else:
                    return True
                self.index += 1
                return True
            if nextVal == '=':
                if self.value == '<':
                    self.value = parse.LESSQ
                elif self.value == '>':
                    self.value == parse.GREATERQ
                elif self.value == '!=':
                    self.value == parse.NOTEQUAL
                else:
                    return True
                self.index += 1
            return True
                                
            
                        
        def span(self, lead):
            if self.value == parse.STRING:
                lead = self.text[lead:].index('"') + lead + 1
                while lead > 0 and self.text[lead-2] == '\\':
                    lead = self.text[lead:].index('"') + lead + 1
                if lead < 1:
                    lead = len(self.text)
                    if self.reader.readln() == None:
                        return lead
                    self.text += '\n' + self.reader.string
                    return self.span(lead)
                return lead
            elif self.value == parse.IDENTIFIER:
                if lead >= len(self.text):
                    return lead
                lead += 1
                current = self.text[lead]
                while ((current >= 'a' and current <= 'z') or
                       (current >= 'A' and current <= 'Z') or
                       (current >= '0' and current <= '9') or
                       current == '_'):
                    if lead == len(self.text):
                        return lead
                    lead += 1
                    current = self.text[lead]  
                return lead - 1
            
            elif self.value == parse.NUMBER:
                if lead >= len(self.text):
                    return lead
                lead += 1
                current = self.text[lead]
                while current >= '0' and current <= '9':
                    if lead == len(self.text):
                        return lead
                    lead += 1
                    current = self.text[lead]  
            
                if current == '.':
                    lead += 1
                    current = self.text[lead]
                    while current >= '0' and current <= '9':
                        if lead == len(self.text):
                            return lead
                        lead += 1
                        current = self.text[lead]  
                if current == 'e' or current == 'E':
                    lead += 1
                    current = self.text[lead]
                    if current == '+' or current == parse.MINUS:
                        lead += 1
                        current = self.text[lead]
                        while current >= '0' and current <= '9':
                            if lead == len(self.text):
                                return lead
                            lead += 1
                            current = self.text[lead]  
                return lead - 1
                
            elif (self.value == parse.LOGICALAND or 
                  self.value == parse.LOGICALOR or 
                  self.value == parse.LESSQ or 
                  self.value == parse.GREATERQ or 
                  self.value == parse.NOTEQUAL or 
                  self.value == parse.EQUALS):
                return lead + 1
            
    def __init__(self, text): 
        self.line = 1
        newtext = text.replace(" ", "")
        newtext = newtext.replace("\t", "")
        self.text = []
        for i in filter(None, newtext.split('\n')):
            self.text.append(i)
        self.string = self.readln()
        self.preview = False
        self.trailer = False
        self.tokens = [parse.parseToken(self), 
                       parse.parseToken(self), 
                       parse.parseToken(self)]
                       
    def token(self):
        return self.tokens[parse.CURRENT].value
        
    def tokenString(self):
        return str(self.tokens[parse.CURRENT])
                       
    def __str__(self):
        value = self.tokenString()[1: -1]
        n = 0
        while n < len(value):
            n = value.index('\\', n)     
            if n < 0:
                break
            if value[n+1] == 'n':
                value = value[0:n] + '\n' + value[n+2]
                n += 1
            elif value[n+1] == 't':
                value = value[0:n] + '\t' + value[n+2]
                n += 1
            else:
                value = value[0:n] + value[n+1]
                n += 1
        return value
                
    def readln(self):
        self.string = self.text.pop(0)
        self.line += 1
        self.index = 0
        self.undo = 0
        return self.string
    
    def newToken(self):
        if self.trailer:
            token = self.tokens[parse.CURRENT]
            self.tokens[parse.CURRENT] = self.tokens[parse.PREVIEW];
            self.tokens[parse.PREVIEW] = self.tokens[parse.TRAILER];
            self.tokens[parse.TRAILER] = token
            self.trailer = False
        elif self.preview:
            token = self.tokens[parse.CURRENT]
            self.tokens[parse.CURRENT] = self.tokens[parse.PREVIEW]
            self.tokens[parse.PREVIEW] = token
            self.preview = False
        else:
            self.index = self.tokens[parse.CURRENT].parse()
        return self.tokens[parse.CURRENT].value()

    def previewToken(self):
        if not self.preview:
            self.index = self.token[parse.PREVIEW].parse()
            self.preview = True
        return self.token[parse.PREVIEW].value
        
    def previewString(self):
        if not self.preview:
            self.index = self.token[parse.PREVIEW].parse()
            self.preview = True
        return str(self.token[parse.PREVIEW])
        
    def trailerToken(self):
        if not self.preview:
            self.index = self.token[parse.PREVIEW].parse()
            self.preview = True
        if not self.trailer:
            self.undo = self.index
            self.index = self.token[parse.Trailer].parse()
            self.preview = True
        return self.token[parse.PREVIEW].value
        
