# -*- coding: utf-8 -*-
"""
Created on Thu Nov 24 09:24:16 2016

@author: akibdpt
"""
from enum import Enum

class colorMode():
    class Model(Enum):
        RGB = 0
        HSV = 1
        
    class Behavior(Enum):
        RGB_MAX = 0
        RGB_ALPHA = 1
        RGB_AVG = 2
        RGB_SUM = 3
    
    MAX_ALPHA = 1 #transparency of color
    MAX_RGB_VALUES = [255]
    MAX_HSV_VALUES = [1]
        
        
    """
    argList = [['a','HSV/HSB/RGB', ''],                        #color model
               ['a','RGB_MAX/RGB_ALPHA/RGB_AVG/RGB_SUM', ''],  #color behavior
               ['0', float value, ''],                         #1st value/ alpha
               ['0', float value, ''],                         #2nd value/ 1st value
               ['0', float value, ''],                         #3rd value/ 2nd value
               ['0', float value, ',']]                        #         / 3rd value
    """
    def __init__(self, argList):
        m = colorMode.Model
        b = colorMode.Behavior
        
        current = 0
        if argList[current][0] != "a":
            raise ValueError(argList[current], "Expected an identifier argument ('a')")
        modelStr = argList[current][1]
        if modelStr == 'HSV' or modelStr == 'HSB':
            model = m.HSV
        elif modelStr == 'RGB':
            model = m.RGB
        else:
            raise ValueError(argList[current], "Expected 'RGB', 'HSV' or 'HSB'")
        behavior = b.RGB_MAX
        if argList[current][2] == ',':
            self.model = model
            self.behavior = behavior
            self.max_alpha = 0
            self.max_cvalues = None
        
        current +=1
        if argList[current][0] != "a":
            raise ValueError(argList[current], "Expected an identifier argument ('a')")
        behaviorstr = argList[current][1]
        if behaviorstr == 'RGB_ALPHA' or behaviorstr == 'ALPHA':
            model = b.RGB_ALPHA
        elif behaviorstr == 'RGB_AVG' or behaviorstr == 'AVG':
            model = b.RGB_AVG
        elif behaviorstr == 'RGB_SUM' or behaviorstr == 'SUM':
            model = b.RGB_SUM
        elif behaviorstr == 'RGB_MAX' or behaviorstr == 'MAX':
            model = b.RGB_MAX
        else: 
            raise ValueError(argList[current], "Expected 'RGB_MAX', 'RGB_ALPHA', 'RGB_AVG' or 'RGB_SUM'")
        if argList[current][2] == ',':
            self.model = model
            self.behavior = behavior
            self.max_alpha = 0
            self.max_cvalues = None
            
        current +=1
        if argList[current][0] != "0":
            raise ValueError(argList[current], "Number expected ('0')")
        alpha = 0;
        value = argList[current][1]
        
        if argList[current][2] != ',' :
            values = [None,None,None,None]
            values[0] = value
            i = 1
            while i < 4 and argList[current][2] != ',':
                current +=1
                if argList[current][0] != "0":
                    raise ValueError(argList[current], "Number expected ('0')")
                value[i] = argList[current][1]
                i+=1
            
            if i == 4:
                if behavior == b.RGB_ALPHA:
                    alpha = values[0]
                values = values[1:4]

        else:
            values = [value]
        self.model = model
        self.behavior = behavior
        self.max_alpha = alpha
        self.max_cvalues = values
        
    def max_alpha(self):
        if self.max_alpha > 0:
            return self.max_alpha
        return self.MAX_ALPHA
        
    def max_cvalues(self):
        if self.max_cvalues is not None:
            return self.max_cvalues
        if self.model == colorMode.Model.HSV:
            return self.MAX_HSV_VALUES
        return self.MAX_RGB_VALUES

    