# -*- coding: utf-8 -*-
"""
Created on Mon Aug  8 15:04:12 2016

@author: akibdpt
"""
"""
 * A Sort can be considered as a class structure, specifying either
 * a single data type or a composition of other class structures.
 * Conceptually, a sort is a set of similar values or models, i.e.,
 * {sortal.ind.Individual}s, that can be unifiably described. The
 * specification of a sort includes a specification of the algebraic behavior
 * of its {Form}s, i.e., collections of individuals.
 * A sort may also be assigned a name; naming sorts serves for referencing
 * as well as to distinguish sorts that may otherwise be identical.
 * 
 * A sort can be either a {SimpleSort} or a composite sort.
 *
 * A {PrimitiveSort} specifies a single data type, and is defined by
 * its characteristic individual and its behavioral category.
 *
 * An {Aspect} defines a single, unidirectional view of a relational data
 * type linking two sorts (and defined as an {AspectsSort}).
 *
 * Both primitive sorts and aspects are simple; these always have a name
 * assigned. All other sorts are composite; their naming is optional.
 *
 * An {AttributeSort} specifies a composition of a primitive sort
 * (its base) with any other sort (its weight) under an object-attribute
 * relationship.
 *
 * A {DisjunctiveSort} specifies a co-ordinate composition of any number
 * of sorts.
 *
 * A {RecursiveSort} is any sort that is recursively defined.
 * A recursive sort necessarily has a name assigned.
 * 
 * The Sort class is an abstract class specifying the common ground
 * for all sortal classes. This common representation includes the context
 * (see {Sorts}) in which the sort is registered, the description of
 * the sort, the semantic base of the sort, an optional name, and the
 * following counts: the number of named components, the number of simple
 * components, and the number of all components.
 *
 * The description of a sort is a string in {sortal.io.sdl.SDL} format that
 * defines this sort, without naming it. The semantic base of a sort is a sort
 * that is (syntactically identical and) semantically equivalent and is
 * determined for the purpose of comparing sorts for semantic equivalence.
 * Two sorts are semantically equivalent if they are both semantically derived,
 * through one or more (re)naming operations, from the same semantic base.
 * A semantic base is itself not semantically derived from any other sort.
 * In the case of a simple sort (or a recursive sort), it is any sort that is
 * not defined through a renaming operation. In the case of a (non-recursive)
 * composite sort, it is any unnamed sort.
 *
 * The name of a sort must be an identifier, i.e., a composition of letters,
 * digits and/or underscores, not starting with a digit.
"""
class sort():
    register = []

    def __init__(self,  name=None):
        self.name = name
        sort.register.append(name)
        return
        
    """
    not yet implemented
    """
    def checkSort(self, name):
        if name not in sort.register:
            return True
        else:
            return False
            
    """
    not yet implemented
    """
    def registerSort(self, name):
        sort.register[name] = self
            
    """
    checking if two sorts are the same
    the two sorts are the same if they have the same name and same description
    """
    def __eq__(self, other):
        if other is None or not isinstance(other, sort):
            return False
        return (self.name == other.name) and (self.description == other.description)
    
    """
    """
    def compareValue(self, other):
        if self.name == other.name:
            if str(self.__dict__) > str(other.__dict__):
                return 1
            elif str(self.__dict__) < str(other.__dict__):
                return -1
            else: 
                return 0
        elif self.name > other.name:
            return 1
        else: 
            return -1

    """
    getting the base sort of the sort
    most sorts (primitive sort and disjunctive sort) have itself as the base sort,
    however attribute sorts have a different base sort.
    this function will only be called by primitive sorts and disjunctive sorts
    """
    def baseSort(self):
        return self

    """
    less than
    """
    def __lt__(self, other):
        if self.name < other.name:
            return True
        if str(self.__dict__) < str(other.__dict__):
            return True
        return False
        
    """
    less than or equal to
    """
    def __le__(self, other):
        if self.name <= other.name:
            return True
        if str(self.__dict__) <= str(other.__dict__):
            return True
        return False
        
    """
    greater than
    """
    def __gt__(self, other):
        if self.name > other.name:
            return True
        if str(self.__dict__) > str(other.__dict__):
            return True
        return False
        
    """
    greater than or equal to
    """
    def __ge__(self, other):
        if self.name >= other.name:
            return True
        if str(self.__dict__) >= str(other.__dict__):
            return True
        return False    
        
    """
    creating a form of the sort
    """
    def newForm(self):
        raise NotImplementedError 
        
'''
to be implemented...

def assign(self)
def names(self)
def components(self)
def setStats(self)
name()
'''